---
title: llarp::layers::platform::OSTraffic_IO_Base

---

# llarp::layers::platform::OSTraffic_IO_Base





## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[OSTraffic_IO_Base](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-ostraffic-io-base)**([PlatformDriver](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md) & ) |
| const [PlatformAddr](Classes/structllarp_1_1layers_1_1platform_1_1PlatformAddr.md) & | **[our_platform_addr](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-our-platform-addr)**() const<br>get the platform address of the underlying device managed.  |
| void | **[attach](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-attach)**(std::shared_ptr< [vpn::NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) > netif)<br>attach to a vpn interface. sets up io handlers.  |
| virtual std::vector< [OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md) > | **[read_platform_traffic](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-read-platform-traffic)**() const<br>read from the os.  |
| virtual void | **[write_platform_traffic](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-write-platform-traffic)**(std::vector< [OSTraffic](Classes/structllarp_1_1layers_1_1platform_1_1OSTraffic.md) > && traff) const<br>write traffic to the os.  |

## Protected Attributes

|                | Name           |
| -------------- | -------------- |
| [PlatformDriver](Classes/classllarp_1_1layers_1_1platform_1_1PlatformDriver.md) & | **[_parent](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#variable--parent)**  |
| std::shared_ptr< [vpn::NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) > | **[_netif](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#variable--netif)**  |

## Public Functions Documentation

### function OSTraffic_IO_Base

```cpp
explicit OSTraffic_IO_Base(
    PlatformDriver & 
)
```


### function our_platform_addr

```cpp
const PlatformAddr & our_platform_addr() const
```

get the platform address of the underlying device managed. 

### function attach

```cpp
void attach(
    std::shared_ptr< vpn::NetworkInterface > netif
)
```

attach to a vpn interface. sets up io handlers. 

### function read_platform_traffic

```cpp
virtual std::vector< OSTraffic > read_platform_traffic() const
```

read from the os. 

this MUST NOT have any internal userland buffering from previous calls to [read_platform_traffic()](Classes/classllarp_1_1layers_1_1platform_1_1OSTraffic__IO__Base.md#function-read-platform-traffic). 


### function write_platform_traffic

```cpp
virtual void write_platform_traffic(
    std::vector< OSTraffic > && traff
) const
```

write traffic to the os. 

## Protected Attributes Documentation

### variable _parent

```cpp
PlatformDriver & _parent;
```


### variable _netif

```cpp
std::shared_ptr< vpn::NetworkInterface > _netif;
```


-------------------------------

Updated on 2023-02-01 at 19:28:29 +0000